<!--- -->
<fusedoc language="ColdFusion 4.5.2" specification="2.0">
	<responsibilities> 
		I take a search engine safe URL and copy the variables
		it contains into the URL structure, based on the SES 
		functionality of formurl2attributessearch.cfm by 
		Steve Nelson.
		
		Instead of using index.cfm?variable=value you would use:
		index.cfm/variables/value.cfm
		If you are using formURL2attributes, you will call this tag first
		If you use this tag you won't use formurl2attributesSearch
	</responsibilities>
	<properties>
		<property name="version" value="1.3" />
		<property name="lastUpdated" value="20-Nov-2001" />
		<history author="Erik Voldengen" email="erikv@erikv.com" role="Architect" type="Create">
			Started with Steve Nelson's formurl2attributes tag
			and hacked it into this.
		</history>
		<history author="Erik Voldengen" email="erikv@erikv.com" role="Architect" type="Update">
			Please note this is NOT equiv code to the CF5 version.  This should work
			find on a standard NT/IIS configuration.  There could be issues outside
			of this, however.  If someone wants to port the cf5 version over for 
			CF 4.0 and 4.5, please contact me.
		</history>
	</properties>
	<io>
		<in></in>
		<out>
			<string scope="variables" name="BaseHREF" optional="No"  comments="the variable containing the <base href>" />
		</out>
	</io>
</fusedoc> --->

<cfoutput>
<!--  #GetFileFromPath(GetCurrentTemplatePath())#  -->
</cfoutput>

<cfsetting enablecfoutputonly="yes">

<!--- This will convert URL variables to attribute variables --->
<cfif isdefined("cgi.query_string") and isdefined("cgi.path_info")>
	<cfif not len(cgi.query_string)>
		<!--- This will support Search Engine capable URLs
			ex: http://127.0.0.1/index.cfm/fuseaction/shoppingcart/additems/127,88/myvar/hello+world --->
		<cfparam name="cleanpathinfo" default="#cgi.path_info#">
		
		<cfset findindex=findnocase("index.cfm",cleanpathinfo)>
		<cfif findindex>
			<cfset cleanpathinfo=RemoveChars(cleanpathinfo, 1, findindex+9)>
		</cfif>
		
		<cfif len(cleanpathinfo)>
			<!--- If you want to append .htm onto the end of your URL, this will clean it 
				so it doesn't affect your variables --->
			<cfif len(cleanpathinfo) gte 4 and right(cleanpathinfo,4) is ".cfm">
				<cfset cleanpathinfo=RemoveChars(cleanpathinfo, len(cleanpathinfo)-3, 4)>
			</cfif>
			
			
			<cfloop index="i" from="1" to="#listlen(cleanpathinfo, "/")#" step="2"> 
				<cfset urlname = listgetat(cleanpathinfo, i, "/")>
				<cfif listlen(cleanpathinfo,"/") gte i+1>
					<cfset urlvalue = listgetat(cleanpathinfo, i + 1, "/")>
					<!--- This will allow you to pass slashes in your values, escape your / with a slash_ --->
					<cfset urlvalue=replacenocase(urlvalue,"slash_","/","all")>
					<CFIF refindnocase("[[:alpha:]]",left(trim(urlname),1)) and NOT ISDEFINED( 'URL.' & urlname )>
						<cfswitch expression="#urlname#">
							<cfcase value="cfid">
								<cfparam name="url.cfid" default="#urlvalue#">
							</cfcase>
							<cfcase value="cftoken">
								<cfparam name="url.cftoken" default="#urlvalue#">
							</cfcase>
							<cfdefaultcase>
								<cfif urlvalue is "null">
								    <cfset "url.#urlname#" = ""> 
								<cfelse> 
								    <cfset "url.#urlname#" = urlvalue> 
								</cfif>
							</cfdefaultcase>
						</cfswitch>
					</cfif>
				</cfif>
			</cfloop>
		</cfif>
	</cfif>
</cfif>

<!--- this is so that your relative images will work, this is only needed if your using search engine urls --->
<cfparam name="url.displaybase" default=true>
<cfif url.displaybase>
	<CFSET s_Prefix = "http">
	<CFIF CGI.HTTPS EQ "ON">
		<CFSET s_Prefix = "https">
	</CFIF>
	<CFSET s_Port = "">
	<CFIF CGI.SERVER_PORT NEQ "80">
		<CFSET s_Port = ":" & CGI.SERVER_PORT>
	</CFIF>
	<CFSET s_Base = REReplace(CGI.SCRIPT_NAME, "[^/]+\.cfm.*", "")>
	<CFSET BaseHREF = s_Prefix & "://" & CGI.SERVER_NAME & s_Port & s_Base>
</cfif>
<cfsetting enablecfoutputonly="No">
